package com.danitheskunk.skunkstuff;


import com.danitheskunk.skunkstuff.Blocks.Blocks;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.Material;
import org.quiltmc.qsl.block.extensions.api.QuiltBlockSettings;

import java.lang.reflect.InvocationTargetException;

public class BlockBuilder extends QuiltBlockSettings {
	public String name;
	public CreativeModeTab creativeModeTab = CreativeModeTab.TAB_MISC;
	public Class<? extends Block> blockClass;
	public Block block;

	public BlockBuilder() {
		super(QuiltBlockSettings.of(Material.WOOD));
		strength(2);
		opaque(false);
		blockClass = Block.class;
	}

	public BlockBuilder name(String name) {
		this.name = name;
		return this;
	}

	public BlockBuilder creativeModeTab(CreativeModeTab creativeModeTab) {
		this.creativeModeTab = creativeModeTab;
		return this;
	}

	public BlockBuilder type(Class<? extends Block> blockClass) {
		this.blockClass = blockClass;
		return this;
	}

	public Block build() {
		try {
			var constructor =
				blockClass.getDeclaredConstructor(BlockBehaviour.Properties.class);
			block = constructor.newInstance(this);
		} catch(NoSuchMethodException | InvocationTargetException |
				InstantiationException | IllegalAccessException e) {
			throw new RuntimeException(e);
		}
		Blocks.addToDeffered(this);
		return block;
	}

	private enum BlockType {
		Full, Slab
	}
}
